/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryItemHighlightType_$type } from "./CategoryItemHighlightType";
import { MarkerType_$type } from "./MarkerType";
import { Brush } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Base, enumGetBox, fromEnum, typeCast, Point_$type, markType, markDep, runOn } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Rect } from "igniteui-angular-core";
import { MarkerSeries } from "./MarkerSeries";
import { DataContext } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, truncate } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Marker } from "./Marker";
import { BrushUtil } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { DataTemplatePassInfo } from "igniteui-angular-core";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
/**
 * @hidden
 */
export let CategoryItemHighlightLayer = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayer extends AnnotationLayer {
        constructor() {
            super();
            this.rd = false;
            this.rc = true;
            this.rg = 10;
            let a = new CategoryItemHighlightLayerFrame();
            let b = new CategoryItemHighlightLayerFrame();
            let c = new CategoryItemHighlightLayerFrame();
            this.p5 = a;
            this.p4 = b;
            this.p6 = c;
            this.ab = CategoryItemHighlightLayer.$;
        }
        get_db() {
            return true;
        }
        bx() {
            return new CategoryItemHighlightLayerView(this);
        }
        ly(a) {
            super.ly(a);
            this.q7 = a;
        }
        qo(a, b) {
            if (this.rb == null || this.rb == a) {
                if (!this.as.c) {
                    this.mh(b);
                }
            }
        }
        qb(a) {
            if (!super.qb(a)) {
                return false;
            }
            if (this.rp != null) {
                if (a.du) {
                    let b = a.jp();
                    if (!Base.equalsStatic(this.rp, b)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(this.rp, a.name)) {
                        return false;
                    }
                }
            }
            let c = this.qj(a);
            if (!c.c) {
                return false;
            }
            return true;
        }
        qq(a, b) {
            super.qq(a, b);
            let c = a;
            let d = this.rf;
            c.g.clear();
            if (isNaN_(this.q4.x) && isNaN_(this.q4.y)) {
                return;
            }
            if (this.qb(this.rb)) {
                this.rv(this.rb, c, d);
            }
            else {
                for (let e of fromEnum(this.cd.series)) {
                    if (this.qb(e)) {
                        this.rv(e, c, d);
                    }
                    if (e.isStacked) {
                        e.la((f) => {
                            if (this.qb(f)) {
                                this.rv(f, c, d);
                            }
                            return true;
                        });
                    }
                }
            }
        }
        l3(a, b, c, d) {
            super.l3(a, b, c, d);
            switch (b) {
                case CategoryItemHighlightLayer.$$p[4]:
                case CategoryItemHighlightLayer.$$p[5]:
                case CategoryItemHighlightLayer.$$p[2]:
                case CategoryItemHighlightLayer.$$p[3]:
                    this.mh(true);
                    break;
                case CategoryItemHighlightLayer.$$p[7]:
                case CategoryItemHighlightLayer.$$p[8]:
                    this.mh(true);
                    break;
                case CategoryItemHighlightLayer.$$p[9]:
                    this.rd = d;
                    this.mh(true);
                    break;
                case CategoryItemHighlightLayer.$$p[1]:
                    this.mh(true);
                    break;
                case CategoryItemHighlightLayer.$$p[0]:
                    this.rg = this.rh;
                    this.mh(true);
                    break;
                case CategoryItemHighlightLayer.$$p[6]:
                    this.rc = d;
                    this.mh(true);
                    break;
            }
        }
        rv(a, b, c) {
            if (this.b0 == null || this.b0.bv.isEmpty || this.b0.bu.isEmpty) {
                return;
            }
            if (!a.dg && !a.dp) {
                return;
            }
            let d = a;
            if (d.categoryAxis == null) {
                return;
            }
            let e = this.q4.x;
            e = this.b0.bu.left + this.b0.bu.width * (e - this.b0.bv.left) / this.b0.bv.width;
            let f = this.q4.y;
            f = this.b0.bu.top + this.b0.bu.height * (f - this.b0.bv.top) / this.b0.bv.height;
            let g = this.re;
            let h = true;
            let i = typeCast(IHasCategoryModePreference_$type, a);
            let j = 0;
            if (i != null) {
                j = i.preferredCategoryMode(d.categoryAxis);
                if (j == 2) {
                    h = false;
                }
            }
            let k = true;
            if (!h || this.q8 == 2) {
                k = false;
            }
            if (this.q8 == 1) {
                k = true;
            }
            let l = this.qj(a);
            if (!l.c) {
                return;
            }
            if (k) {
                let m = a.pl(l.d, this.rf, g);
                if (j != 0 && !d.categoryAxis.cm) {
                    let n = m.x;
                    if (a.dp) {
                        n -= a.getOffsetValue();
                        n += a.getCategoryWidth() * 0.5;
                        m = { $type: Point_$type, x: n, y: m.y };
                    }
                    else if (a.dg) {
                        n -= a.getOffsetValue();
                        n += a.getCategoryWidth() * 0.5;
                        m = { $type: Point_$type, x: n, y: m.y };
                    }
                }
                if (!isNaN_(m.x) && !isNaN_(m.y)) {
                    m = this.po(m);
                }
                this.rt(m, b, a);
            }
            else {
                let o = a.pl(l.d, this.rf, g);
                let p;
                let q = this.getEffectiveViewport1(this.b0);
                if (a.isVertical) {
                    let r = o.y;
                    let s = d.categoryAxis;
                    let t = this.rg;
                    if (j != 0) {
                        t = s.k3(this.b0.bv, this.b0.bu, q);
                    }
                    if (isNaN_(t) || isInfinity(t)) {
                        return;
                    }
                    p = new Rect(0, this.py.left, r - t / 2, this.py.width, t);
                }
                else {
                    let u = o.x;
                    let v = d.categoryAxis;
                    let w = this.rg;
                    if (j != 0) {
                        w = v.k3(this.b0.bv, this.b0.bu, q);
                    }
                    if (isNaN_(w) || isInfinity(w)) {
                        return;
                    }
                    p = new Rect(0, u - w / 2, this.py.top, w, this.py.height);
                }
                p.intersect(this.b0.bu);
                this.ru(p, b, a);
            }
        }
        rt(a, b, c) {
            let d = new ItemHighlightFrameRect();
            d.b = a.x;
            d.e = a.y;
            d.i = this.q2();
            if (this.r9 != null) {
                d.i = this.r9;
            }
            d.j = this.q3();
            if (this.sa != null) {
                d.j = this.sa;
            }
            if (d.i == null) {
                if (c.hasMarkers) {
                    d.i = this.q7.ci(c.o5());
                }
                else {
                    d.i = this.q7.ci(c.oy);
                }
            }
            if (d.j == null) {
                if (c.hasMarkers) {
                    d.j = this.q7.ci(c.o6());
                }
                else {
                    d.j = this.q7.ci(c.o1);
                }
            }
            d.d = this.fu;
            d.f = Base.getHashCodeStatic(c);
            d.g = this.q9(c, a);
            let e = (typeCast(MarkerSeries.$, c) !== null) ? c.qw : null;
            if (e == null || e == MarkerSeries.qz || (this.ra != 2 && this.ra != 0)) {
                let f = MarkerSeries.qd(c, 2);
                if (this.ra != 2 && this.ra != 0) {
                    f = this.ra;
                }
                switch (f) {
                    case 3:
                    case 13:
                        e = this.cd.ov;
                        break;
                    case 4:
                        e = this.cd.o4;
                        break;
                    case 5:
                        e = this.cd.o1;
                        break;
                    case 6:
                        e = this.cd.o2;
                        break;
                    case 7:
                        e = this.cd.ow;
                        break;
                    case 8:
                        e = this.cd.oz;
                        break;
                    case 9:
                        e = this.cd.ox;
                        break;
                    case 10:
                        e = this.cd.o3;
                        break;
                    case 11:
                        e = this.cd.o0;
                        break;
                    case 12:
                        e = this.cd.oy;
                        break;
                }
            }
            d.h = this.ry != null ? this.ry : e;
            if (!isNaN_(d.b) && !isNaN_(d.e)) {
                b.g.addItem(d.f, d);
            }
        }
        q9(a, b) {
            let c = a.ht(b);
            let d = a.f5(b);
            if (this.rf && d != Math.floor(d)) {
                c = null;
            }
            return ((() => {
                let $ret = new DataContext();
                $ret.series = a;
                $ret.item = c;
                return $ret;
            })());
        }
        ru(a, b, c) {
            let d = new ItemHighlightFrameRect();
            d.b = a.left;
            d.e = a.top;
            d.c = a.right;
            d.a = a.bottom;
            d.i = this.q2();
            d.j = this.q3();
            if (d.i == null) {
                if (c != null) {
                    d.i = this.q7.cj(c.oy);
                }
            }
            if (d.j == null) {
                if (c != null) {
                    d.j = this.q7.cj(c.o1);
                }
            }
            d.d = this.fu;
            d.f = Base.getHashCodeStatic(c);
            if (!a.isEmpty) {
                b.g.addItem(d.f, d);
            }
        }
        qt(a, b) {
            super.qt(a, b);
            let c = this.q7.b6;
            let d = this.q7.b5;
            let e = 0;
            let f = 0;
            let g = a;
            for (let h of fromEnum(g.g.values)) {
                if (h.h != null) {
                    let i = d.item(f);
                    this.rw(h, i);
                    f++;
                }
                else {
                    let j = c.item(e);
                    this.rx(h, j);
                    e++;
                }
            }
            c.count = e;
            d.count = f;
        }
        rw(a, b) {
            if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.d) || a.g == null) {
                b._visibility = 1;
                return;
            }
            let c = { $type: Point_$type, x: a.b, y: a.e };
            let d = a.g;
            d.itemBrush = a.i;
            let e = d.series.pl(c, this.cv() || this.rd, this.rc);
            if (isNaN_(e.x) || isNaN_(e.y)) {
                b._visibility = 1;
                return;
            }
            this.q7.cc(b, e.x, e.y);
            b.ah = a.h;
            b.content = a.g;
        }
        rx(a, b) {
            if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
                b._visibility = 1;
                return;
            }
            this.q7.cd(b, a.b, a.e, a.c - a.b, a.a - a.e);
            b._fill = a.i;
            b._stroke = a.j;
            b.ac = a.d;
            if (this.pb != null) {
                b.ai = this.pb;
            }
            else {
                b.ai = null;
            }
            b.ad = this.pc;
        }
        em() {
            return true;
        }
    }
    CategoryItemHighlightLayer.$t = markType(CategoryItemHighlightLayer, 'CategoryItemHighlightLayer', AnnotationLayer.$);
    CategoryItemHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryItemHighlightLayer, 'raisePropertyChanged', ['BandHighlightWidth:rh:rz', [1, 10], 'HighlightType:q8:r0', [CategoryItemHighlightType_$type, enumGetBox(CategoryItemHighlightType_$type, 0)], 'MarkerBrush:r9:r1', [Brush.$, null], 'MarkerOutline:sa:r2', [Brush.$, null], 'MarkerTemplate:ry:r3', [DataTemplate.$, null], 'MarkerType:ra:r4', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'SkipUnknownValues:re:r5', [0, true], 'TargetSeriesName:rp:r6', [2, null], 'TargetSeries:rb:r7', [Series.$, null], 'UseInterpolation:rf:r8', [0, false]]);
    return CategoryItemHighlightLayer;
})();
/**
 * @hidden
 */
export let CategoryItemHighlightLayerView = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b6 = null;
            this.b5 = null;
            this.b7 = null;
            this.b8 = null;
            this.b4 = a;
            this.b7 = new List$1(ContentControl.$, 0);
            this.b8 = new List$1(Rectangle.$, 0);
        }
        as() {
            super.as();
            this.b6 = ((() => {
                let $ret = new Pool$1(Rectangle.$);
                $ret.create = runOn(this, this.ck);
                $ret.activate = runOn(this, this.ce);
                $ret.disactivate = runOn(this, this.cg);
                $ret.destroy = runOn(this, this.cf);
                return $ret;
            })());
            this.b5 = ((() => {
                let $ret = new Pool$1(ContentControl.$);
                $ret.create = runOn(this, this.ch);
                $ret.activate = runOn(this, this.b9);
                $ret.disactivate = runOn(this, this.cb);
                $ret.destroy = runOn(this, this.ca);
                return $ret;
            })());
        }
        ck() {
            let a = new Rectangle();
            a.ab = false;
            this.b8.add(a);
            return a;
        }
        ce(a) {
            a._visibility = 0;
        }
        cg(a) {
            a._visibility = 1;
        }
        cf(a) {
            this.b8.remove(a);
        }
        ch() {
            let a = new Marker();
            this.b7.add(a);
            return a;
        }
        b9(a) {
            a._visibility = 0;
        }
        cb(a) {
            a._visibility = 1;
        }
        ca(a) {
            this.b7.remove(a);
        }
        ci(a) {
            if (a == null) {
                return a;
            }
            return BrushUtil.l(a, 0.3);
        }
        cj(a) {
            if (a != null) {
                let b = BrushUtil.l(a, 0.3);
                if (b.isGradient) {
                    let c = b;
                    if (c.gradientStops != null) {
                        for (let d = 0; d < c.gradientStops.length; d++) {
                            let e = c.gradientStops[d];
                            e.color = Color.u(truncate(Math.round((e.color.l) * 0.3)), e.color.o, e.color.n, e.color.m);
                            e.color = e.color;
                        }
                    }
                }
                else {
                    b.color = Color.u(truncate(Math.round((b.color.l & 255) * 0.3)), b.color.o, b.color.n, b.color.m);
                    b.color = b.color;
                }
                return b;
            }
            else {
                return null;
            }
        }
        cd(a, b, c, d, e) {
            a._visibility = 0;
            a.n = b;
            a.o = c;
            a.width = d;
            a.height = e;
        }
        cc(a, b, c) {
            a.n = b;
            a.o = c;
        }
        bh(a, b) {
            super.bh(a, b);
            let c = a;
            let d = c.content;
            if (d != null) {
                if (d.itemBrush != null) {
                    d.actualItemBrush = d.itemBrush;
                }
                let e = d.series;
                if (e.hasMarkers) {
                    d.outline = e.o6();
                }
                d.thickness = e.f2();
            }
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d && !b) {
                for (let c = 0; c < this.b8.count; c++) {
                    let d = this.b8._inner[c];
                    if (d._visibility == 0) {
                        a.v(d);
                    }
                }
                if (this.b7.count > 0) {
                    let e = new DataTemplatePassInfo();
                    e.isHitTestRender = b;
                    e.context = a.g();
                    e.viewportTop = this.bu.top;
                    e.viewportLeft = this.bu.left;
                    e.viewportWidth = this.bu.width;
                    e.viewportHeight = this.bu.height;
                    e.passID = "ItemMarkers";
                    let f = new DataTemplateRenderInfo();
                    f.isHitTestRender = b;
                    f.passInfo = e;
                    let g = new DataTemplateMeasureInfo();
                    g.passInfo = e;
                    let h = false;
                    let i = a.g();
                    g.context = i;
                    f.context = i;
                    g.renderContext = a;
                    f.renderContext = a;
                    let j = 0;
                    let k = 0;
                    let l = new Dictionary$2(DataTemplate.$, DataTemplate.$, 0);
                    for (let m = 0; m < this.b7.count; m++) {
                        let n = this.b7._inner[m];
                        let o = n.ah;
                        if (!l.containsKey(o)) {
                            l.addItem(o, o);
                            if (o != null && o.passStarting != null) {
                                o.passStarting(e);
                            }
                        }
                        if (n._visibility == 1) {
                            continue;
                        }
                        this.bg(n, m, b);
                        if (!h) {
                            g.data = n.content;
                            g.width = n.width;
                            g.height = n.height;
                            if (o.measure != null) {
                                g.data = n.content;
                                o.measure(g);
                                h = g.isConstant;
                                if (h) {
                                    j = g.width;
                                    k = g.height;
                                }
                            }
                            f.availableWidth = g.width;
                            f.availableHeight = g.height;
                        }
                        else {
                            f.availableWidth = j;
                            f.availableHeight = k;
                        }
                        if (!isNaN_(n.width) && !isInfinity(n.width)) {
                            f.availableWidth = n.width;
                        }
                        if (!isNaN_(n.height) && !isInfinity(n.height)) {
                            f.availableHeight = n.height;
                        }
                        a.p(f, n);
                        n.m = f.availableWidth;
                        n.l = f.availableHeight;
                    }
                    for (let p of fromEnum(l.keys)) {
                        if (p != null && p.passCompleted != null) {
                            p.passCompleted(e);
                        }
                    }
                }
            }
        }
        al(a) {
            super.al(a);
            for (let b = 0; b < this.b8.count; b++) {
                this.e.a8.exportRectangleData(a, this.b8._inner[b], "catItemRect", ["Main", "CategoryItem"]);
            }
            for (let c = 0; c < this.b7.count; c++) {
                this.e.a8.exportMarkerVisualDataFromMarker(this.e, a, this.b7._inner[c]);
            }
        }
    }
    CategoryItemHighlightLayerView.$t = markType(CategoryItemHighlightLayerView, 'CategoryItemHighlightLayerView', AnnotationLayerView.$);
    return CategoryItemHighlightLayerView;
})();
