/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { FinalValueSelectionMode_$type } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, enumGetBox, fromEnum, Point_$type, markType, markDep } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FinalValueLayer = /*@__PURE__*/ (() => {
    class FinalValueLayer extends AnnotationLayer {
        constructor() {
            super();
            this.axisAnnotationFormatLabel = null;
            this.rd = null;
            this.rc = null;
            let a = new FinalValueLayerFrame();
            let b = new FinalValueLayerFrame();
            let c = new FinalValueLayerFrame();
            let d = this.hm / 1000;
            this.p5 = a;
            this.p4 = b;
            this.p6 = c;
            this.ab = FinalValueLayer.$;
        }
        get_da() {
            return true;
        }
        bx() {
            return new FinalValueLayerView(this);
        }
        ly(a) {
            super.ly(a);
            this.q8 = a;
        }
        get si() {
            return new Thickness(1, this.rg, this.ri, this.rh, this.rf);
        }
        rb() {
            return this.axisAnnotationFormatLabel != null;
        }
        qo(a, b) {
            if (this.ra == null || this.ra == a) {
                if (!this.as.c) {
                    this.mh(b);
                }
            }
        }
        qq(a, b) {
            super.qq(a, b);
            let c = a;
            c.f.clear();
            c.r.clear();
            c.q.clear();
            c.ac.clear();
            c.p.clear();
            c.ab.clear();
            c.h.clear();
            c.g.clear();
            c.i.clear();
            c.k.clear();
            c.m.clear();
            c.l.clear();
            c.j.clear();
            c.n.clear();
            c.o.clear();
            c.t.clear();
            c.s.clear();
            c.u.clear();
            c.w.clear();
            c.y.clear();
            c.x.clear();
            c.v.clear();
            c.z.clear();
            c.aa.clear();
            if (this.qb(this.ra)) {
                this.rz(this.ra, c);
            }
            else {
                for (let d of fromEnum(this.cd.series)) {
                    if (this.qb(d)) {
                        this.rz(d, c);
                    }
                    if (d.isStacked) {
                        d.la((e) => {
                            if (this.qb(e)) {
                                this.rz(e, c);
                            }
                            return true;
                        });
                    }
                }
            }
        }
        qb(a) {
            if (!super.qb(a)) {
                return false;
            }
            if (this.rw != null) {
                if (a.du) {
                    let b = a.jp();
                    if (!Base.equalsStatic(this.rw, b)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(this.rw, a.name)) {
                        return false;
                    }
                }
            }
            return true;
        }
        lr() {
            super.lr();
            if (!this.as.c && !this.cv()) {
                return;
            }
            if (this.cv()) {
                this.r0(this.p6, false);
            }
            else {
                this.r0(this.p4, false);
            }
        }
        sh(a) {
            let b = NaN;
            let c = NaN;
            let d = this.q9;
            if (d == 0) {
                d = 1;
            }
            let e = false;
            if (d == 2) {
                e = true;
            }
            if (a.isVertical) {
                let f = a.ar();
                if (f != null) {
                    if (d == 1 || d == 2) {
                        if (f.cg) {
                            c = a.po({ $type: Point_$type, x: this.py.right, y: this.py.bottom }).y;
                        }
                        else {
                            c = a.po({ $type: Point_$type, x: this.py.right, y: this.py.top }).y;
                        }
                    }
                    else {
                        if (f.cg) {
                            c = 1;
                        }
                        else {
                            c = 0;
                        }
                    }
                }
                return a.pl({ $type: Point_$type, x: 0, y: c }, e, true);
            }
            else {
                let g = a.ar();
                if (g != null) {
                    if (d == 1 || d == 2) {
                        if (g.cg) {
                            b = a.po({ $type: Point_$type, x: this.py.left, y: this.py.top }).x;
                        }
                        else {
                            b = a.po({ $type: Point_$type, x: this.py.right, y: this.py.top }).x;
                        }
                    }
                    else {
                        if (g.cg) {
                            b = 0;
                        }
                        else {
                            b = 1;
                        }
                    }
                }
                if (a.dp) {
                    return a.pl({ $type: Point_$type, x: b, y: 0 }, e, true);
                }
                else {
                    return a.pl({ $type: Point_$type, x: b, y: 0 }, e, true);
                }
            }
        }
        rz(a, b) {
            let c = this.sh(a);
            let d = this.po(c);
            let e = this.oy;
            if (e == null) {
                e = this.o2;
            }
            if (e == null) {
                e = a.oy;
                if (e != null) {
                    e = this.q8.b5(e);
                }
            }
            AxisAnnotationFrameManager.c(b, c, a, this.cd, this.getEffectiveViewport(), e, this.se, this.re, this.sg, this.sf, this.si, this.rj, this.se, this.re, this.sg, this.sf, this.si, this.rj, a.isVertical, !a.isVertical);
        }
        r0(a, b) {
            let c = false;
            if (this.rc == null) {
                c = true;
                this.rd = new List$1(Axis.$, 0);
                this.rc = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.rc, this.rd, b, this.rk, this.rk, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
        }
        qt(a, b) {
            super.qt(a, b);
            if (this.cv()) {
                this.r0(this.p6, true);
            }
            else {
                this.r0(this.p4, false);
            }
        }
        em() {
            return true;
        }
        l3(a, b, c, d) {
            super.l3(a, b, c, d);
            switch (b) {
                case FinalValueLayer.$$p[11]:
                case FinalValueLayer.$$p[12]:
                    this.mh(true);
                    break;
                case FinalValueLayer.$$p[1]:
                case FinalValueLayer.$$p[0]:
                case FinalValueLayer.$$p[3]:
                case FinalValueLayer.$$p[5]:
                case FinalValueLayer.$$p[7]:
                case FinalValueLayer.$$p[6]:
                case FinalValueLayer.$$p[4]:
                case FinalValueLayer.$$p[8]:
                case FinalValueLayer.$$p[9]:
                case FinalValueLayer.$$p[10]:
                    this.mh(true);
                    break;
                case "SeriesViewer":
                    let e = this.rd;
                    let f = this.rc;
                    if (f != null) {
                        for (let g of fromEnum(f)) {
                            let h = g.value;
                            h.c((i) => g.key.am.remove(i));
                            h.clear();
                        }
                        e.clear();
                        f.clear();
                    }
                    break;
            }
        }
    }
    FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
    FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:re:r1', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:se:r2', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:rk:r3', [1, -1], 'AxisAnnotationOutline:sf:r4', [Brush.$, null], 'AxisAnnotationPaddingBottom:rf:r5', [1, NaN], 'AxisAnnotationPaddingLeft:rg:r6', [1, NaN], 'AxisAnnotationPaddingRight:rh:r7', [1, NaN], 'AxisAnnotationPaddingTop:ri:r8', [1, NaN], 'AxisAnnotationStrokeThickness:rj:r9', [1, NaN], 'AxisAnnotationTextColor:sg:sa', [Brush.$, null], 'FinalValueSelectionMode:q9:sb', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeriesName:rw:sc', [2, null], 'TargetSeries:ra:sd', [Series.$, null]]);
    return FinalValueLayer;
})();
/**
 * @hidden
 */
export let FinalValueLayerView = /*@__PURE__*/ (() => {
    class FinalValueLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b4 = a;
        }
        as() {
            super.as();
        }
        b5(a) {
            if (a == null) {
                return a;
            }
            return BrushUtil.l(a, 0.1);
        }
        al(a) {
            super.al(a);
        }
    }
    FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
    return FinalValueLayerView;
})();
