/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, typeCast, runOn, markType, markDep } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { ScatterSplineSeriesView } from "./ScatterSplineSeriesView";
import { Defaults } from "./Defaults";
import { Clipper } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { PathGeometry } from "igniteui-angular-core";
import { Numeric } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterSplineSeries = /*@__PURE__*/ (() => {
    class ScatterSplineSeries extends ScatterBase {
        constructor() {
            super();
            this.ab = ScatterSplineSeries.$;
            this.r2 = new ScatterFrame();
            this.r4 = new ScatterFrame();
            this.r0 = new ScatterFrame();
        }
        get_eg() {
            return true;
        }
        bx() {
            return new ScatterSplineSeriesView(this);
        }
        gu() {
            if (!isNaN_(this.gt)) {
                return super.gu();
            }
            return Defaults.x;
        }
        l3(a, b, c, d) {
            super.l3(a, b, c, d);
            switch (b) {
                case ScatterSplineSeries.$$p[0]:
                    this.mh(false);
                    this.lo();
                    break;
            }
        }
        bp() {
            if (this.bq == 0) {
                return 2;
            }
            else {
                return super.bp();
            }
        }
        tw(a, b) {
            super.tw(a, b);
            a.m.clear();
            a.u.clear();
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.ft * this.ft;
            let g = Math.min(this.sc != null ? this.sc.count : 0, this.sd != null ? this.sd.count : 0);
            let h = new ScalerParams(0, c, d, this.rw.d, e);
            let i = ((() => {
                let $ret = new ScalerParams(0, c, d, this.rw.e, e);
                $ret.b = this.gc();
                return $ret;
            })());
            let j = (k) => this.rw.a.ei(this.sc.item(k), h);
            let k = (l) => this.rw.b.ei(this.sd.item(l), i);
            let l = ((() => {
                let $ret = new Clipper(0, d, false);
                $ret.i = a.m;
                return $ret;
            })());
            for (let m = 0; m < g;) {
                let n = m;
                ++m;
                while (m < g && this.u1(j, k, n, m) < f) {
                    ++m;
                }
                if (g > this.sx) {
                    l.j(this.u5(j, k, n, m - 1));
                }
                else {
                    let o = new OwnedPoint();
                    o.c = { $type: Point_$type, x: j(n), y: k(n) };
                    o.a = this.ck.item(n);
                    if (!a.u.containsKey(o.a)) {
                        a.u.addItem(o.a, o);
                    }
                }
            }
            if (g > this.sx) {
                l.i = null;
            }
        }
        u5(a, b, c, d) {
            if (c == d) {
                return { $type: Point_$type, x: a(c), y: b(c) };
            }
            let e = 0;
            let f = 0;
            let g = (d - c + 1);
            for (let h = c; h <= d; ++h) {
                e += a(h);
                f += b(h);
            }
            return { $type: Point_$type, x: e / g, y: f / g };
        }
        u1(a, b, c, d) {
            let e = a(d) - a(c);
            let f = b(d) - b(c);
            return e * e + f * f;
        }
        get_sk() {
            return true;
        }
        kx(a, b) {
            super.kx(a, b);
            let c = typeCast(ScatterSplineSeriesView.$, b);
            c.c4(false);
        }
        t7(a, b) {
            this.kx(false, b);
            super.t7(a, b);
            this.tz(a);
            let c = typeCast(ScatterSplineSeriesView.$, b);
            let d = c.dg;
            this.r9.ax(this, this.sp(), runOn(this, this.rk));
            let e = false;
            let f = this.r9.b;
            if (f != null) {
                e = true;
            }
            if (e) {
                this.ts(-1, this.sc.count, b.q);
            }
            this.r9.ad(d, true, false, true, false);
            c.dg.ak = new PathGeometry();
            c.dg.ak.c = Numeric.h(a.m.count, (g) => a.m._inner[g].x, (g) => a.m._inner[g].y, this.u2);
        }
    }
    ScatterSplineSeries.$t = markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
    ScatterSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:u2:u4', [1, 0.5]]);
    return ScatterSplineSeries;
})();
