import { fromPoint, toPoint, ensureBool } from "igniteui-angular-core";
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export class IgxPlotAreaMouseButtonEventArgs {
    constructor() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get chartPosition() {
        return fromPoint(this.i.chartPosition);
    }
    set chartPosition(v) {
        this.i.chartPosition = toPoint(v);
    }
    get plotAreaPosition() {
        return fromPoint(this.i.plotAreaPosition);
    }
    set plotAreaPosition(v) {
        this.i.plotAreaPosition = toPoint(v);
    }
    get manipulationOccurred() {
        return this.i.manipulationOccurred;
    }
    set manipulationOccurred(v) {
        this.i.manipulationOccurred = ensureBool(v);
    }
    /**
     * Gets the Chart associated with the current event.
    */
    get viewer() {
        if (this.i.viewer == null) {
            return null;
        }
        return this.i.viewer.externalObject;
    }
    set viewer(v) {
        v == null ? this.i.viewer = null : this.i.viewer = v.i;
    }
}
