/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, typeCast, runOn, markType, markDep } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { ScatterSplineSeriesView } from "./ScatterSplineSeriesView";
import { Defaults } from "./Defaults";
import { Clipper } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { PathGeometry } from "igniteui-angular-core";
import { Numeric } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var ScatterSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSplineSeries, _super);
    function ScatterSplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = ScatterSplineSeries.$;
        _this.r2 = new ScatterFrame();
        _this.r4 = new ScatterFrame();
        _this.r0 = new ScatterFrame();
        return _this;
    }
    ScatterSplineSeries.prototype.get_eg = function () {
        return true;
    };
    ScatterSplineSeries.prototype.bx = function () {
        return new ScatterSplineSeriesView(this);
    };
    ScatterSplineSeries.prototype.gu = function () {
        if (!isNaN_(this.gt)) {
            return _super.prototype.gu.call(this);
        }
        return Defaults.x;
    };
    ScatterSplineSeries.prototype.l3 = function (a, b, c, d) {
        _super.prototype.l3.call(this, a, b, c, d);
        switch (b) {
            case ScatterSplineSeries.$$p[0]:
                this.mh(false);
                this.lo();
                break;
        }
    };
    ScatterSplineSeries.prototype.bp = function () {
        if (this.bq == 0) {
            return 2;
        }
        else {
            return _super.prototype.bp.call(this);
        }
    };
    ScatterSplineSeries.prototype.tw = function (a, b) {
        var _this = this;
        _super.prototype.tw.call(this, a, b);
        a.m.clear();
        a.u.clear();
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.ft * this.ft;
        var g = Math.min(this.sc != null ? this.sc.count : 0, this.sd != null ? this.sd.count : 0);
        var h = new ScalerParams(0, c, d, this.rw.d, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, _this.rw.e, e);
            $ret.b = _this.gc();
            return $ret;
        })());
        var j = function (k) { return _this.rw.a.ei(_this.sc.item(k), h); };
        var k = function (l) { return _this.rw.b.ei(_this.sd.item(l), i); };
        var l = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (var m = 0; m < g;) {
            var n = m;
            ++m;
            while (m < g && this.u1(j, k, n, m) < f) {
                ++m;
            }
            if (g > this.sx) {
                l.j(this.u5(j, k, n, m - 1));
            }
            else {
                var o = new OwnedPoint();
                o.c = { $type: Point_$type, x: j(n), y: k(n) };
                o.a = this.ck.item(n);
                if (!a.u.containsKey(o.a)) {
                    a.u.addItem(o.a, o);
                }
            }
        }
        if (g > this.sx) {
            l.i = null;
        }
    };
    ScatterSplineSeries.prototype.u5 = function (a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a(c), y: b(c) };
        }
        var e = 0;
        var f = 0;
        var g = (d - c + 1);
        for (var h = c; h <= d; ++h) {
            e += a(h);
            f += b(h);
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    };
    ScatterSplineSeries.prototype.u1 = function (a, b, c, d) {
        var e = a(d) - a(c);
        var f = b(d) - b(c);
        return e * e + f * f;
    };
    ScatterSplineSeries.prototype.get_sk = function () {
        return true;
    };
    ScatterSplineSeries.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        c.c4(false);
    };
    ScatterSplineSeries.prototype.t7 = function (a, b) {
        this.kx(false, b);
        _super.prototype.t7.call(this, a, b);
        this.tz(a);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        var d = c.dg;
        this.r9.ax(this, this.sp(), runOn(this, this.rk));
        var e = false;
        var f = this.r9.b;
        if (f != null) {
            e = true;
        }
        if (e) {
            this.ts(-1, this.sc.count, b.q);
        }
        this.r9.ad(d, true, false, true, false);
        c.dg.ak = new PathGeometry();
        c.dg.ak.c = Numeric.h(a.m.count, function (g) { return a.m._inner[g].x; }, function (g) { return a.m._inner[g].y; }, this.u2);
    };
    ScatterSplineSeries.$t = markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
    ScatterSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:u2:u4', [1, 0.5]]);
    return ScatterSplineSeries;
}(ScatterBase));
export { ScatterSplineSeries };
