import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries } from "igniteui-angular-core";
import { ISupportsSizeScale } from "./ISupportsSizeScale";
import { ISupportsFillScale } from "./ISupportsFillScale";
import { Rect } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { SeriesView } from "./SeriesView";
import { MarkerFillMode } from "./MarkerFillMode";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { BrushSelectionMode } from "./BrushSelectionMode";
import { MarkerManagerBase } from "./MarkerManagerBase";
/**
 * @hidden
 */
export declare class BubbleSeries extends ScatterBase implements IScaleLegendSeries, ISupportsSizeScale, ISupportsFillScale {
    static $t: Type;
    protected get_c4(): boolean;
    protected bx(): SeriesView;
    ly(a: SeriesView): void;
    u4: BubbleSeriesView;
    protected gv(): number;
    p6(): MarkerFillMode;
    constructor();
    private wu;
    private wt;
    isAttachedTo(a: IChartLegend): boolean;
    protected c3(): boolean;
    protected k9(a: (arg1: any) => void): void;
    get vb(): IFastItemColumn$1<number>;
    vh: List$1<UIElement>;
    private ws;
    get legendReady(): boolean;
    get minScaleText(): string;
    get maxScaleText(): string;
    forScaleColors(a: (arg1: Brush, arg2: number) => void): boolean;
    v6: string;
    hw(a: any, b: string): any;
    get vd(): IFastItemColumn$1<number>;
    set vd(a: IFastItemColumn$1<number>);
    private u9;
    u6: SizeScale;
    vw: string;
    private u8;
    get vc(): IFastItemColumn$1<any>;
    set vc(a: IFastItemColumn$1<any>);
    vr: string;
    u3: BrushScale;
    private u7;
    get va(): IFastItemColumn$1<number>;
    set va(a: IFastItemColumn$1<number>);
    ve: boolean;
    vf: boolean;
    vl: number;
    vk: number;
    vg: boolean;
    to(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    tw(a: ScatterFrame, b: ScatterBaseView): void;
    private wb;
    static vi(a: number, b: number, c: number, d: number, e: number): number;
    static vj(a: number, b: number, c: number, d: number, logBase_: number, e: number): number;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    protected sl(a: string, b: FastItemsSourceEventAction): boolean;
    private wa;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    lh(): void;
    ln(): void;
    protected l3(a: any, b: string, c: any, d: any): void;
    updateSizeScaleGlobals(): void;
    updateFillScaleGlobals(): void;
    u2(a: SizeScale): ActualRange;
    u1(): ActualRange;
    u5: SizeScale;
    wd(a: List$1<Marker>, b: List$1<number>, c: Rect, d: boolean): void;
    wc(a: List$1<Marker>): void;
    v2: string;
    vn: string;
    v4: string;
    vp: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    get actualMarkerBrush(): Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CustomPaletteBrushScale extends BrushScale {
    static $t: Type;
    constructor();
    brushSelectionMode: BrushSelectionMode;
    getBrush1(a: number, b: number): Brush;
    protected get_isReady(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BubbleSeriesView extends ScatterBaseView {
    static $t: Type;
    protected df: BubbleSeries;
    constructor(a: BubbleSeries);
    as(): void;
    protected cu(): MarkerManagerBase;
    dh(): void;
    di(): void;
    dg(): void;
    getDefaultTooltipTemplate(): string;
}
