import { Type } from "igniteui-angular-core";
/**
 * Describes available options for constraining the tooltip to different bounds.
 */
export declare enum DataTooltipConstraintMode {
    /**
     * A constraint for the tooltip is selected automatically.
     */
    Auto = 0,
    /**
     * The tooltip is constrained within the bounds of the application window.
     */
    Application = 1,
    /**
     * The tooltip is constrained within the bounds of the chart.
     */
    Chart = 2,
    /**
     * The tooltip is constrained within the bounds of the chart plot area.
     */
    PlotArea = 3,
    /**
     * The tooltip is constrained within the bounds of the screen.
     */
    None = 4
}
/**
 * @hidden
 */
export declare let DataTooltipConstraintMode_$type: Type;
