import { Series } from "./Series";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { PriceDisplayType } from "./PriceDisplayType";
import { CategoryMode } from "./CategoryMode";
import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export interface IFinancialPriceSeriesProxy {
    setOpenMemberPath(a: Series, b: string): void;
    setHighMemberPath(a: Series, b: string): void;
    setLowMemberPath(a: Series, b: string): void;
    setCloseMemberPath(a: Series, b: string): void;
    setVolumeMemberPath(a: Series, b: string): void;
    setXAxis(a: Series, b: CategoryAxisBase): void;
    setYAxis(a: Series, b: NumericYAxis): void;
    setDisplayType(a: Series, b: PriceDisplayType): void;
    setCategoryMode(a: Series, b: CategoryMode): void;
    matchesType(a: Series): boolean;
    getOpenMemberPath(a: Series): string;
    getHighMemberPath(a: Series): string;
    getLowMemberPath(a: Series): string;
    getCloseMemberPath(a: Series): string;
    getVolumeMemberPath(a: Series): string;
}
/**
 * @hidden
 */
export declare let IFinancialPriceSeriesProxy_$type: Type;
