import { Base, Point, Type, EventArgs, INotifyPropertyChanged, IEnumerable, IList, PropertyChangedEventArgs } from "igniteui-angular-core";
import { DomRenderer, DomWrapper } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { EventProxy } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { PieChartStyleInfo } from "./PieChartStyleInfo";
import { BrushCollection } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PieChartVisualData } from "./PieChartVisualData";
import { Style } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Control } from "igniteui-angular-core";
import { Line } from "igniteui-angular-core";
import { LabelsPosition } from "./LabelsPosition";
import { Visibility } from "igniteui-angular-core";
import { LeaderLineType } from "./LeaderLineType";
import { ILegendOwner } from "igniteui-angular-core";
import { ILegendSeries } from "igniteui-angular-core";
import { ILegendTemplateProvider } from "igniteui-angular-core";
import { FastItemsSource } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { OthersCategoryType } from "./OthersCategoryType";
import { IndexCollection } from "./IndexCollection";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { IChartLegend } from "igniteui-angular-core";
import { SweepDirection } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { SliceSelectionMode } from "./SliceSelectionMode";
import { ObjectCollection } from "igniteui-angular-core";
import { BindingFormatter } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core";
import { SelectedItemChangingEventArgs } from "./SelectedItemChangingEventArgs";
import { SelectedItemsChangingEventArgs } from "./SelectedItemsChangingEventArgs";
import { SelectedItemChangedEventArgs } from "./SelectedItemChangedEventArgs";
import { SelectedItemsChangedEventArgs } from "./SelectedItemsChangedEventArgs";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { PieSliceVisualData } from "./PieSliceVisualData";
import { MouseEventArgs } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class PieChartViewManager extends Base {
    static $t: Type;
    n: DomRenderer;
    protected p: DomWrapper;
    protected s: DomWrapper;
    protected r: DomWrapper;
    protected q: DomWrapper;
    private k;
    private j;
    private l;
    protected ap: Rect;
    e: RenderingContext;
    g: RenderingContext;
    f: RenderingContext;
    h: RenderingContext;
    private a;
    constructor(a: PieChartBaseView);
    aa(): void;
    ad(a: number, b: number): void;
    ae(): void;
    ab(): void;
    z(): void;
    w(a: number, b: number): void;
    ao(): Rect;
    d(): FontInfo;
    an(): Point;
    ah(a: () => void): void;
    b(): PieChartStyleInfo;
    ai(a: Path): void;
    c: EventProxy;
    ac(a: any): void;
    v(a: DomWrapper): void;
    af(a: boolean): void;
    t(): any;
    x(a: PieChartVisualData): void;
    private _toolTipObject;
    private u;
    private i;
    ak(a: any): void;
    aj(pos_: Point, context_: PieSliceDataContext): void;
    y(a: PieSliceDataContext): void;
    al(style_: Style): Brush;
    am(style_: Style): Brush;
    m(style_: Style): number;
    ag(): void;
}
/**
 * @hidden
 */
export declare class LabelClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get item(): any;
    get allowSliceClick(): boolean;
    set allowSliceClick(a: boolean);
    private c;
}
/**
 * @hidden
 */
export declare class SliceClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get isSelected(): boolean;
    set isSelected(a: boolean);
    private d;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    private c;
    get isOthersSlice(): boolean;
    get index(): number;
    get dataContext(): any;
    private _originalEvent;
    get originalEvent(): any;
    set originalEvent(a: any);
    get origin(): Point;
    get radius(): number;
    get bounds(): Rect;
    get startAngle(): number;
    get endAngle(): number;
    get fill(): Brush;
    get outline(): Brush;
}
/**
 * @hidden
 */
export declare class SliceEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get isSelected(): boolean;
    set isSelected(a: boolean);
    private d;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    private c;
    get isOthersSlice(): boolean;
    get index(): number;
    get origin(): Point;
    get radius(): number;
    get bounds(): Rect;
    get startAngle(): number;
    get endAngle(): number;
    get fill(): Brush;
    get outline(): Brush;
    get dataContext(): any;
    private _originalEvent;
    get originalEvent(): any;
    set originalEvent(a: any);
}
/**
 * @hidden
 */
export declare class PieLabel extends Control {
    static $t: Type;
    constructor();
    ah: Slice;
    ao: Rect;
    ai: number;
    aj: any;
    ap: Line;
    aq: Path;
    ag: LabelsPosition;
    ak(a: PieChartBaseView): void;
    al(): void;
    am(): void;
    an(): void;
}
/**
 * @hidden
 */
export declare abstract class PieChartBase extends Control implements INotifyPropertyChanged, ILegendOwner, ILegendSeries, ILegendTemplateProvider {
    static $t: Type;
    a2(): PieChartBaseView;
    gl(a: PieChartBaseView): void;
    a3: PieChartBaseView;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    private by;
    private b1;
    private b0;
    private b2;
    private bz;
    private b5;
    private b4;
    private b3;
    private readonly a7;
    private readonly cs;
    private readonly cu;
    private readonly ct;
    private readonly cv;
    private di;
    bk: FastItemsSource;
    private bo;
    get bt(): IFastItemColumn$1<number>;
    set bt(a: IFastItemColumn$1<number>);
    dk: number;
    dc: number;
    dh: number;
    cm: List$1<number>;
    cl: List$1<number>;
    ck: List$1<any>;
    c2: number;
    cj: List$1<UIElement>;
    get cz(): number;
    a6: PieChartSliceSelector;
    private _xsr;
    private get XSRP();
    get d7(): string;
    itemsSource: IEnumerable;
    actualItemsSource: IEnumerable;
    static readonly hm: DependencyProperty;
    get c8(): number;
    set c8(a: number);
    fs: string;
    eh: string;
    ew: string;
    private bm;
    get bp(): IFastItemColumn$1<any>;
    set bp(a: IFastItemColumn$1<any>);
    private bn;
    get bq(): IFastItemColumn$1<any>;
    set bq(a: IFastItemColumn$1<any>);
    az: LabelsPosition;
    ix: Brush;
    iw: Brush;
    iv: Brush;
    iu: Brush;
    ja: Visibility;
    i6: Style;
    a0: LeaderLineType;
    da: number;
    dp: any;
    db: number;
    a1: OthersCategoryType;
    e3: string;
    c3: number;
    get cy(): number;
    de: number;
    get c1(): number;
    b7: boolean;
    b6: boolean;
    get explodedSlices(): IndexCollection;
    set explodedSlices(a: IndexCollection);
    private au;
    legend: IChartLegend;
    c9: number;
    dg: number;
    iz: SweepDirection;
    get selectedSlices(): IndexCollection;
    set selectedSlices(a: IndexCollection);
    private av;
    i7: Style;
    i8: Style;
    i9: Style;
    am: BrushCollection;
    ak: BrushCollection;
    an: BrushCollection;
    al: BrushCollection;
    ed: string;
    ag: any[];
    e7: string;
    aj: any[];
    et: string;
    ah: any[];
    ey: string;
    ai: any[];
    legendItemTemplate: DataTemplate;
    legendItemBadgeTemplate: DataTemplate;
    static readonly hx: DependencyProperty;
    get g9(): DataTemplate;
    set g9(a: DataTemplate);
    cc: boolean;
    cd: boolean;
    cf: boolean;
    cg: boolean;
    protected b9(): boolean;
    protected ca(): boolean;
    a4: (obj: any) => string;
    a5: (obj: any) => string;
    private cx;
    get dd(): number;
    set dd(a: number);
    private cw;
    get c0(): number;
    set c0(a: number);
    bi: SliceSelectionMode;
    get selectedItem(): any;
    set selectedItem(a: any);
    static readonly ij: DependencyProperty;
    private _selectedItems;
    get selectedItems(): ObjectCollection;
    set selectedItems(a: ObjectCollection);
    labelClick: (sender: any, e: LabelClickEventArgs) => void;
    ga(a: any, b: LabelClickEventArgs): void;
    selectedItemChanging: (sender: any, e: SelectedItemChangingEventArgs) => void;
    gc(a: any, b: SelectedItemChangingEventArgs): void;
    selectedItemsChanging: (sender: any, e: SelectedItemsChangingEventArgs) => void;
    gf(a: any, b: SelectedItemsChangingEventArgs): void;
    selectedItemChanged: (sender: any, e: SelectedItemChangedEventArgs) => void;
    gb(a: any, b: SelectedItemChangedEventArgs): void;
    selectedItemsChanged: (sender: any, e: SelectedItemsChangedEventArgs) => void;
    gd(a: any, b: SelectedItemsChangedEventArgs): void;
    sliceClick: (sender: any, e: SliceClickEventArgs) => void;
    gh(a: any, b: SliceClickEventArgs): void;
    bv: Pool$1<Slice>;
    bu: Pool$1<PieLabel>;
    fw(a: Slice, b: boolean): void;
    gz(a: Slice, b: boolean): void;
    g0(a: Slice): void;
    dm(a: Slice): any;
    i4(a: Slice, b: LabelsPosition): Rect;
    b8(a: PieLabel, b: Point): boolean;
    static df(a: number): number;
    private cb;
    private static c4;
    static g5(a: List$1<PieLabel>): void;
    gx(a: List$1<PieLabel>): void;
    protected fu(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gt(): void;
    gm(): void;
    go(): void;
    private fe;
    gn(): void;
    i5: Rect;
    gw(): void;
    gu(): void;
    private static c5;
    private static i0;
    private static c6;
    private static i1;
    gv(): void;
    bj(): PieChartVisualData;
    d2(): string;
    protected br(a: string): IFastItemColumn$1<number>;
    protected bs(a: string): IFastItemColumn$1<any>;
    ap: BindingFormatter;
    as: BindingFormatter;
    aq: BindingFormatter;
    ar: BindingFormatter;
    protected gp(a: any, b: string, c: any, d: any): void;
    protected ao(a: BrushCollection): BrushCollection;
    protected iy(a: Brush): Brush;
    private fd;
    private ff;
    private cn;
    protected cq(): IEnumerable;
    protected gy(a: NotifyCollectionChangedEventArgs): void;
    protected ge(a: NotifyCollectionChangedEventArgs): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected gr(a: string, b: any, c: any): void;
    private g8;
    private g7;
    g3(a: Slice, b: MouseEventArgs): void;
    g4(a: Slice, b: MouseEventArgs, c: boolean): void;
    g2(a: Point): void;
    ce(a: Slice, b: MouseEventArgs): boolean;
    private dl;
    fy(a: any, b: any): void;
    sliceEnter: (sender: any, e: SliceEventArgs) => void;
    sliceLeave: (sender: any, e: SliceEventArgs) => void;
    sliceHover: (sender: any, e: SliceEventArgs) => void;
    private be;
    private gi;
    private gj;
    private gk;
    f1(a: any, b: any, c: boolean): void;
    f0(a: any, b: any): void;
    fz(a: any, b: MouseEventArgs): void;
    gg(): void;
    provideContainer(a: any): void;
    f8(a: number, b: number): void;
    notifyContainerResized(): void;
    i3(): Rect;
    i2(): Point;
    destroy(): void;
    fx(): void;
    private dq;
    get fn(): string;
    set fn(a: string);
    get container(): ILegendOwner;
    get isStacked(): boolean;
    get isVertical(): boolean;
    get hasMarkers(): boolean;
    get isUsableInLegend(): boolean;
    get hasSubItems(): boolean;
    c7(a: Slice): number;
    f6(source_: any, a: number, b: any, c: any): void;
    f2(source_: any): void;
    private ch;
    static ci(a: any, b: any): boolean;
    f4(source_: any, a: number, b: any): void;
    f5(source_: any, a: number, b: any): void;
    g1(source_: any): void;
    gs(): void;
    g6(): void;
    bl(): FontInfo;
    resolveLegendIndex(): number;
    forSubItems(a: (arg1: any) => void): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartSliceSelector extends Base {
    static $t: Type;
    private a;
    constructor(a: PieChartBase);
    d(a: Slice): boolean;
    c(a: Slice): boolean;
    h(a: Slice): any;
    f(a: any, b: boolean): boolean;
    e(a: any): boolean;
    g(a: any): boolean;
    b(a: any): boolean;
    k(a: Slice): void;
    i(a: Slice): void;
    j(a: Slice): void;
}
/**
 * @hidden
 */
export declare class PieSliceOthersContext extends Base {
    static $t: Type;
    private _data;
    get data(): IList;
    set data(a: IList);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
}
/**
 * @hidden
 */
export declare class Slice extends ContentControl {
    static $t: Type;
    ak(): SliceView;
    bl(a: SliceView): void;
    al: SliceView;
    constructor();
    a3: number;
    ax: number;
    a1: number;
    a0: number;
    static readonly bv: DependencyProperty;
    get isSelected(): boolean;
    set isSelected(a: boolean);
    static readonly bt: DependencyProperty;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    static readonly bu: DependencyProperty;
    get isOthersSlice(): boolean;
    set isOthersSlice(a: boolean);
    b7: Point;
    b5: Point;
    a2: number;
    ay: number;
    a5: number;
    get b2(): Brush;
    set b2(a: Brush);
    static readonly bp: DependencyProperty;
    a4: number;
    b8: Rect;
    ai: PieChartBase;
    aj: PieLabel;
    bf: string;
    b9: Rect;
    b3: Point;
    aq: boolean;
    au: boolean;
    av: boolean;
    ac(): void;
    az(): number;
    private cb;
    b6(): Point;
    private an;
    get aw(): boolean;
    set aw(a: boolean);
    bk(): void;
    ap(a: Point): boolean;
    private ao;
    private ca;
    am(): PieSliceVisualData;
    private static b4;
    cc: Rect;
    b0: Brush;
    b1: Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartBaseView extends Base {
    static $t: Type;
    constructor(a: PieChartBase);
    a: PieChartBase;
    a2(): void;
    bc(): void;
    ay(): void;
    a1(): void;
    bt: Brush;
    b: PieChartStyleInfo;
    protected h: RenderingContext;
    j: RenderingContext;
    protected i: RenderingContext;
    protected k: RenderingContext;
    c: PieChartViewManager;
    az(a: any): void;
    b2(): Rect;
    bz(): Point;
    bb(): void;
    b4: Rect;
    private l;
    aw(): void;
    private bj;
    private b1;
    protected a6(): void;
    protected a7(): void;
    private a9;
    private ba;
    private a8;
    private n;
    ak(a: Point, b: boolean, c: boolean): void;
    aj(a: Point): void;
    private by;
    private m;
    ai(a: Point): void;
    al(a: Point): void;
    private aq;
    protected f: Slice;
    private bk;
    o(a: Point): boolean;
    q(a: Point): boolean;
    p(a: Point): boolean;
    private be;
    am(): void;
    bo(a: any, b: any): void;
    protected v: List$1<Slice>;
    g(): Slice;
    bf(a: Slice): void;
    bh(a: Slice): void;
    bg(a: Slice): void;
    protected u: List$1<PieLabel>;
    d(): PieLabel;
    as(a: PieLabel): void;
    au(a: PieLabel): void;
    at(a: PieLabel): void;
    bm(a: PieLabel): void;
    bd(a: Slice): void;
    private bw;
    private bx;
    ae(a: Slice): any;
    z(a: any): number;
    bl(): void;
    w: number;
    y(a: any): number;
    b3(a: PieLabel): Rect;
    b5(): Size;
    bn(a: PieLabel, b: number, c: number): void;
    bq(a: any): void;
    bs(): void;
    av(): void;
    private an;
    a0(a: number, b: number): void;
    ax(): void;
    protected b0: Point;
    protected ah: any;
    protected t: boolean;
    protected e: PieSliceDataContext;
    get ag(): any;
    ar(): void;
    br(a: any): void;
    bp(a: Point, b: any, c: any): void;
    bi(): void;
    a3(): void;
    ad(): any;
    ap(): void;
    s(): boolean;
    ao(a: PieChartVisualData): void;
    r(): boolean;
    a5(): void;
    bu(a: Slice): Brush;
    bv(a: Slice): Brush;
    x(a: Slice): number;
    aa(a: Style): number;
    ab(): number;
    a4(): void;
    af(a: any): any;
}
/**
 * @hidden
 */
export declare class PieSliceDataContext extends DataContext {
    static $t: Type;
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    private _percentValue;
    get percentValue(): number;
    set percentValue(a: number);
    private _isOthersSlice;
    get isOthersSlice(): boolean;
    set isOthersSlice(a: boolean);
    flatten(): any;
}
/**
 * @hidden
 */
export declare class SliceView extends Base {
    static $t: Type;
    protected a: Slice;
    constructor(a: Slice);
    g: Path;
    b(): void;
    c(): void;
    f(): Path;
    d(a: number, b: number): void;
    e(): void;
}
