import { Base, Type, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { AssigningRadialStyleEventArgs } from "./AssigningRadialStyleEventArgs";
import { AssigningRadialMarkerStyleEventArgs } from "./AssigningRadialMarkerStyleEventArgs";
import { RadialAxes } from "./RadialAxes";
import { Pool$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class RadialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: RadialBaseView;
    constructor(a: RadialBaseView);
    c: number;
    d: number;
    b: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RadialBase extends MarkerSeries implements IHasCategoryModePreference {
    static $t: Type;
    ly(a: SeriesView): void;
    rt: RadialBaseView;
    constructor();
    private sl;
    get categoryAxis(): CategoryAxisBase;
    ar(): CategoryAxisBase;
    rh(a: number, b: number): any[];
    protected ry: RadialSeriesRenderManager;
    c1(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    private sg;
    rz: SeriesRenderer$2<RadialFrame, RadialBaseView>;
    protected get_ea(): boolean;
    r6: boolean;
    r5: boolean;
    protected r1: boolean;
    protected r0: boolean;
    protected get_dx(): boolean;
    private rp;
    private rq;
    protected rm(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rn(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected ro(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningRadialStyle: (sender: any, args: AssigningRadialStyleEventArgs) => void;
    assigningRadialMarkerStyle: (sender: any, args: AssigningRadialMarkerStyleEventArgs) => void;
    protected sa(): boolean;
    protected r9(): boolean;
    protected so(a: AssigningRadialStyleEventArgs): void;
    protected sn(a: AssigningRadialMarkerStyleEventArgs): void;
    sc(a: SeriesView): number;
    sd(a: SeriesView): number;
    rk: CategoryAngleAxis;
    rr: NumericRadiusAxis;
    ag(): Axis[];
    r4: boolean;
    protected m5(a: Rect, b: Rect): void;
    protected m4(a: Rect, b: Rect): void;
    abstract preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected l3(a: any, b: string, c: any, d: any): void;
    protected r8(): boolean;
    protected r7(): boolean;
    r3(a: any): boolean;
    r2(a: any): boolean;
    ht(a: Point): any;
    sb(a: Point): number;
    f5(a: Point): number;
    hd(a: Point): number;
    en(a: any): boolean;
    rw: RadialFrame;
    rx: RadialFrame;
    ru: RadialFrame;
    rv(): RadialFrame;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    abstract sm(a: RadialFrame, b: RadialBaseView): void;
    abstract sp(a: RadialFrame, b: RadialBaseView): void;
    rs: RadialAxes;
    le(): void;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    mi(a: boolean): void;
    se(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RadialBaseView extends MarkerSeriesView {
    static $t: Type;
    cs: RadialBucketCalculator;
    cr: RadialBase;
    constructor(a: RadialBase);
    ct: Pool$1<Marker>;
    cf(a: (arg1: Marker) => void): void;
    cu: number;
    cv: Point;
}
