import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { List$1 } from "igniteui-angular-core";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
/**
 * @hidden
 */
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    static $t: Type;
    protected bx(): SeriesView;
    getHostReferenceValue(): number;
    ly(a: SeriesView): void;
    tf: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    get RangeFramePreparer(): RangeCategoryFramePreparer;
    set RangeFramePreparer(a: RangeCategoryFramePreparer);
    to: string;
    hw(a: any, b: string): any;
    get lowColumn(): IFastItemColumn$1<number>;
    set lowColumn(a: IFastItemColumn$1<number>);
    private th;
    tl: string;
    get highColumn(): IFastItemColumn$1<number>;
    set highColumn(a: IFastItemColumn$1<number>);
    private tg;
    protected ry(): CategoryTransitionInMode;
    s6(a: CategoryFrame, b: CategorySeriesView): void;
    protected tq(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    aq(a: Rect): AxisRange;
    en(a: any): boolean;
    protected l3(a: any, b: string, c: any, d: any): void;
    ap(a: Axis): AxisRange;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    s3(a: CategoryFrame, b: CategorySeriesView): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get mayContainUnknowns(): boolean;
    mj(a: Rect, b: RenderSurface): void;
    private td;
    mg(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    gc(): number;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RangeCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c0: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    c1(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    cs(): CategoryBucketCalculator;
}
