import { IgxAxisComponent } from "./igx-axis-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { CategoryToolTipLayer } from "./CategoryToolTipLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that displays grouped tooltips for series that use a category axis.
*/
export declare class IgxCategoryToolTipLayerComponent extends IgxAnnotationLayerComponent {
    protected createImplementation(): CategoryToolTipLayer;
    /**
                                 * @hidden
                                 */
    get i(): CategoryToolTipLayer;
    constructor();
    /**
     * Gets whether the series is an annotation layer displayed only when hovering over the chart.
    */
    get isAnnotationHoverLayer(): boolean;
    static ngAcceptInputType_isAnnotationHoverLayer: boolean | string;
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    get isDefaultTooltipBehaviorDisabled(): boolean;
    static ngAcceptInputType_isDefaultTooltipBehaviorDisabled: boolean | string;
    /**
     * Gets or sets the Axis to target this annotation to. If null, this annotation layer will not render content.
    */
    get targetAxis(): IgxAxisComponent;
    set targetAxis(v: IgxAxisComponent);
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    get useInterpolation(): boolean;
    set useInterpolation(v: boolean);
    static ngAcceptInputType_useInterpolation: boolean | string;
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxCategoryToolTipLayerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxCategoryToolTipLayerComponent, "igx-category-tool-tip-layer", never, { "targetAxis": "targetAxis"; "useInterpolation": "useInterpolation"; }, {}, never, never>;
}
