import { IgPoint } from "igniteui-angular-core";
import { IgxSeriesComponent } from "./igx-series-component";
import { IgxSeriesViewerComponent } from "./igx-series-viewer-component";
import { ChartMouseEventArgs as ChartMouseEventArgs_internal } from "./ChartMouseEventArgs";
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export declare class IgxChartMouseEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ChartMouseEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets a reference to the object that raised the event.
    */
    get originalSource(): any;
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item(): any;
    set item(v: any);
    /**
     * Gets the series associated with the current event.
    */
    get series(): IgxSeriesComponent;
    set series(v: IgxSeriesComponent);
    /**
     * Gets the Chart associated with the current event.
    */
    get chart(): IgxSeriesViewerComponent;
    set chart(v: IgxSeriesViewerComponent);
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString(): string;
    /**
     * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
     * against the origin of a supplied UIElement.
    
    * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
     * and connected to the object tree. To specify the object relative to the overall the engine
     * coordinate system, use a relativeTo value of null.
    */
    getPosition(relativeTo: any): IgPoint;
}
