import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { FastStochasticOscillatorIndicator } from "./FastStochasticOscillatorIndicator";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent Fast Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*/
export declare class IgxFastStochasticOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): FastStochasticOscillatorIndicator;
    /**
                                 * @hidden
                                 */
    get i(): FastStochasticOscillatorIndicator;
    constructor();
    /**
     * Gets or sets the moving average period for the current FastStochasticOscillatorIndicator object.
     * The typical, and initial, value for FastStochasticOscillatorIndicator periods is 14.
    */
    get period(): number;
    set period(v: number);
    static ngAcceptInputType_period: number | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxFastStochasticOscillatorIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxFastStochasticOscillatorIndicatorComponent, "igx-fast-stochastic-oscillator-indicator", never, { "period": "period"; }, {}, never, never>;
}
