import { IgxCategoryAxisBaseComponent } from "./igx-category-axis-base-component";
import { IgxNumericYAxisComponent } from "./igx-numeric-y-axis-component";
import { IgxStackedSeriesBaseComponent } from "./igx-stacked-series-base-component";
import { HorizontalStackedSeriesBase } from "./HorizontalStackedSeriesBase";
import * as i0 from "@angular/core";
/**
 * Base class for stacked series with a category x-axis and a numeric y-axis.
*/
export declare abstract class IgxHorizontalStackedSeriesBaseComponent extends IgxStackedSeriesBaseComponent {
    /**
                                 * @hidden
                                 */
    get i(): HorizontalStackedSeriesBase;
    constructor();
    /**
     * Gets or sets the effective x-axis for this series.
    */
    get xAxis(): IgxCategoryAxisBaseComponent;
    set xAxis(v: IgxCategoryAxisBaseComponent);
    get hasValueAxis(): boolean;
    static ngAcceptInputType_hasValueAxis: boolean | string;
    get isValueAxisInverted(): boolean;
    static ngAcceptInputType_isValueAxisInverted: boolean | string;
    /**
     * Gets or sets the effective y-axis for this series.
    */
    get yAxis(): IgxNumericYAxisComponent;
    set yAxis(v: IgxNumericYAxisComponent);
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue(): number;
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth(): number;
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis: any): boolean;
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis: any): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxHorizontalStackedSeriesBaseComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxHorizontalStackedSeriesBaseComponent, "ng-component", never, { "xAxis": "xAxis"; "yAxis": "yAxis"; }, {}, never, never>;
}
