import { LegendBase } from './LegendBase';
/**
 * Represents the base class for a legend in IgxDataChartComponent.
*/
export declare abstract class IgxLegendBaseComponent {
    protected _zoneRunner: (act: () => void) => void;
    protected _implementation: any;
    get i(): LegendBase;
    private onImplementationCreated;
    constructor();
    protected abstract createImplementation(): any;
    /**
 * Gets if the legend is item-wise.
*/
    get isItemwise(): boolean;
    static ngAcceptInputType_isItemwise: boolean | string;
    /**
     * Gets if the legend is a financial legend.
    */
    get isFinancial(): boolean;
    static ngAcceptInputType_isFinancial: boolean | string;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Returns the legend visuals expressed as a serialized string.

*/
    exportSerializedVisualData(): string;
}
