import { IgxStraightNumericAxisBaseComponent } from "./igx-straight-numeric-axis-base-component";
import { NumericXAxis } from "./NumericXAxis";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent numeric X axis.
*
* The `IgxNumericXAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the X-axis. The location of labels varies according to the value in a data column that is mapped using the `XMemberPath` property of Scatter Series or `ValueMemberPath` property of Bar Series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-numeric-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		crossingAxis= "xAxis"
* 		crossingValue= 700
* 		#yAxis>
*     </igx-numeric-y-axis>
* </igx-data-chart>
* ```
*/
export declare class IgxNumericXAxisComponent extends IgxStraightNumericAxisBaseComponent {
    protected createImplementation(): NumericXAxis;
    /**
                                 * @hidden
                                 */
    get i(): NumericXAxis;
    constructor();
    scrollRangeIntoView(minimum: number, maximum: number): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxNumericXAxisComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxNumericXAxisComponent, "igx-numeric-x-axis", never, {}, {}, never, never>;
}
