import { IgxNumericYAxisComponent } from "./igx-numeric-y-axis-component";
import { PercentChangeYAxis } from "./PercentChangeYAxis";
import * as i0 from "@angular/core";
/**
 * A horizontal axis that uses a DateTime scale.
*
* You can use the `IgxPercentChangeYAxisComponent` show percentage values.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-percent-change-y-axis
* 		#yAxis>
*     </igx-percent-change-y-axis>
* </igx-data-chart>
* ```
*
* ```ts
* let yAxis = new IgxPercentChangeYAxisComponent();
* this.chart.axes.add(yAxis);
* ```
*/
export declare class IgxPercentChangeYAxisComponent extends IgxNumericYAxisComponent {
    protected createImplementation(): PercentChangeYAxis;
    /**
                                 * @hidden
                                 */
    get i(): PercentChangeYAxis;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPercentChangeYAxisComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxPercentChangeYAxisComponent, "igx-percent-change-y-axis", never, {}, {}, never, never>;
}
