import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { RadialPieSeries } from "./RadialPieSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent radial pie series.
 * Compare values across categories by using radial pie slices.
*/
export declare class IgxRadialPieSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    protected createImplementation(): RadialPieSeries;
    /**
                                 * @hidden
                                 */
    get i(): RadialPieSeries;
    constructor();
    /**
     * Gets whether the current series shows a pie shape.
    */
    get isPie(): boolean;
    static ngAcceptInputType_isPie: boolean | string;
    /**
     * Overridden by derived series classes to indicate when marker-less display is preferred or not.
    */
    get isMarkerlessDisplayPreferred(): boolean;
    static ngAcceptInputType_isMarkerlessDisplayPreferred: boolean | string;
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX(): number;
    set radiusX(v: number);
    static ngAcceptInputType_radiusX: number | string;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY(): number;
    set radiusY(v: number);
    static ngAcceptInputType_radiusY: number | string;
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan(): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxRadialPieSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxRadialPieSeriesComponent, "igx-radial-pie-series", never, { "radiusX": "radiusX"; "radiusY": "radiusY"; }, {}, never, never>;
}
