import { IgxSplineSeriesBaseComponent } from "./igx-spline-series-base-component";
import { SplineAreaSeries } from "./SplineAreaSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent spline area series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-spline-area-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-spline-area-series>
* </igx-data-chart>
* ```
*/
export declare class IgxSplineAreaSeriesComponent extends IgxSplineSeriesBaseComponent {
    protected createImplementation(): SplineAreaSeries;
    /**
                                 * @hidden
                                 */
    get i(): SplineAreaSeries;
    constructor();
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea(): boolean;
    static ngAcceptInputType_isArea: boolean | string;
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline(): boolean;
    static ngAcceptInputType_isSpline: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxSplineAreaSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxSplineAreaSeriesComponent, "igx-spline-area-series", never, {}, {}, never, never>;
}
