import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { TypicalPriceIndicator } from "./TypicalPriceIndicator";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent Typical Price indicator series.
 * The typical price indicator is represented as a arithmetic average
 * of the High, Low, and Close for a day.
 * Default required members: High, Low, Close
*
* The `IgxTypicalPriceIndicatorComponent` class represents a IgxDataChartComponent Typical Price indicator series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-typical-price-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-typical-price-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxTypicalPriceIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
export declare class IgxTypicalPriceIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): TypicalPriceIndicator;
    /**
                                 * @hidden
                                 */
    get i(): TypicalPriceIndicator;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxTypicalPriceIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxTypicalPriceIndicatorComponent, "igx-typical-price-indicator", never, {}, {}, never, never>;
}
