import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { ValueBrushScale } from "./ValueBrushScale";
import * as i0 from "@angular/core";
/**
 * Represents a brush scale that uses value-based brush selection.
*/
export declare class IgxValueBrushScaleComponent extends IgxBrushScaleComponent {
    protected createImplementation(): ValueBrushScale;
    /**
                                 * @hidden
                                 */
    get i(): ValueBrushScale;
    constructor();
    /**
     * Gets or sets the minimum value for this scale.
    */
    get minimumValue(): number;
    set minimumValue(v: number);
    static ngAcceptInputType_minimumValue: number | string;
    /**
     * Gets or sets the maximum value for this scale.
    */
    get maximumValue(): number;
    set maximumValue(v: number);
    static ngAcceptInputType_maximumValue: number | string;
    /**
     * Gets or sets whether the scale is logarithmic.
    */
    get isLogarithmic(): boolean;
    set isLogarithmic(v: boolean);
    static ngAcceptInputType_isLogarithmic: boolean | string;
    /**
     * Gets or sets the logarithm base for this scale.
    */
    get logarithmBase(): number;
    set logarithmBase(v: number);
    static ngAcceptInputType_logarithmBase: number | string;
    /**
     * Checks if the value brush scale is ready for usage in the chart
    */
    get isReady(): boolean;
    static ngAcceptInputType_isReady: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxValueBrushScaleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxValueBrushScaleComponent, "igx-value-brush-scale", never, { "minimumValue": "minimumValue"; "maximumValue": "maximumValue"; "isLogarithmic": "isLogarithmic"; "logarithmBase": "logarithmBase"; }, {}, never, never>;
}
